; XFORM_4_REGION
; by kero <geocities.com/xmemor>
; v.2008-04-24
;
; MouseWheel (up/down) => hew rotated (+/-45) region instead of old region.
; MiddleClick => +/- "HTCAPTION".

.386
.model flat,stdcall
option casemap: none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32

XFORM4 struct
  eM11  REAL4 ?
  eM12  REAL4 ?
  eM21  REAL4 ?
  eM22  REAL4 ?
  ex    REAL4 ?
  ey    REAL4 ?
XFORM4 ends

.data
  _class db "XFORM_4_REGION",0
  plgn   dd 100,80, 100,50, 180,50, 180,80, 140,100
  angle  dd 45 ; (45)
.data?
  hrgn   HRGN ?
  drdr   dd ?
  x0     dd ?
  y0     dd ?
  htflag dd ?

.code

XformRotation proc angl:DWORD,x:DWORD,y:DWORD,lpxform:DWORD
  local val:DWORD
  mov ecx,lpxform
  assume ecx:ptr XFORM4
  mov val,180
  fldpi
  fimul angl 
  fidiv val
  fsincos
  fst  [ecx].eM11 ; cos
  fstp [ecx].eM22 ; cos
  fst  [ecx].eM12 ; sin
  fchs
  fstp [ecx].eM21 ; -sin
  fild x
  fstp [ecx].ex
  fild y
  fstp [ecx].ey
  assume ecx:nothing
  ret
XformRotation endp

XformRotationRgn proc uses ebx edi rgn:HRGN,angl:DWORD,lpxform:DWORD
  invoke GetRegionData,rgn,0,0
  mov ebx,eax ; (dwCount)
  invoke VirtualAlloc,0,ebx,MEM_COMMIT,PAGE_READWRITE
  mov edi,eax ; (lpRgnData)
  invoke GetRegionData,rgn,ebx,edi
  invoke XformRotation,angl,0,0,lpxform   
  invoke ExtCreateRegion,lpxform,ebx,edi
  push eax
  invoke VirtualFree,edi,0,MEM_RELEASE  
  invoke DeleteObject,rgn
  pop eax ; (new hrgn)
  ret
XformRotationRgn endp

ClientPtInRgn proc uses ebx hWnd:HWND,rgn:HRGN,lppt:DWORD
  mov ebx, lppt
  assume ebx:ptr POINT
  invoke GetCursorPos,ebx
  invoke ScreenToClient,hWnd,ebx
  invoke PtInRegion,rgn,[ebx].x,[ebx].y
  assume ebx:nothing
  ret
ClientPtInRgn endp

WndProc proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local pt:POINT
  local rt:RECT
  local ps:PAINTSTRUCT  
  local xform:XFORM4

  .if uMsg==WM_DESTROY
    invoke DeleteObject,hrgn
    invoke PostQuitMessage,0
    xor eax,eax

  .elseif uMsg==WM_CREATE
    invoke CreatePolygonRgn,addr plgn,4,ALTERNATE
    mov hrgn,eax
    mov eax,80000001h
    jmp @f

  .elseif uMsg==WM_MOUSEWHEEL
    mov eax,wParam
@@:
     mov ecx,angle
    .if eax<80000000h
      neg ecx
    .endif    
    invoke XformRotationRgn,hrgn,ecx,addr xform
    mov hrgn,eax
    invoke InvalidateRect,hWnd,0,1
    xor eax,eax

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    invoke PaintRgn,eax,hrgn
    invoke EndPaint,hWnd,addr ps
    xor eax,eax

  .elseif uMsg==WM_LBUTTONDOWN && drdr==0
    invoke ClientPtInRgn,hWnd,hrgn,addr pt
    .if eax!=0
      mov drdr,eax
      mov eax,pt.x
      mov x0,eax
      mov eax,pt.y
      mov y0,eax
    .endif
    jmp @dwp

  .elseif uMsg==WM_LBUTTONUP && drdr!=0
    xor eax,eax
    mov drdr,eax
    jmp @dwp

  .elseif uMsg==WM_MOUSEMOVE && wParam==MK_LBUTTON
    invoke ClientPtInRgn,hWnd,hrgn,addr pt
    .if drdr!=0
      .if eax!=0
        mov eax,pt.x
        mov edx,x0
        mov x0,eax
        sub eax,edx
        mov ecx,pt.y
        mov edx,y0
        mov y0,ecx
        sub ecx,edx
        invoke OffsetRgn,hrgn,eax,ecx
        invoke InvalidateRect,hWnd,0,1
      .else
        mov drdr,eax
      .endif
    .else
      jmp @dwp
    .endif

  .elseif uMsg==WM_MBUTTONDOWN || uMsg==WM_NCMBUTTONDOWN
    xor htflag,1
    xor eax,eax

  .elseif uMsg==WM_NCHITTEST && htflag!=0
    invoke ClientPtInRgn,hWnd,hrgn,addr pt   
    .if eax==0
      mov eax,HTCAPTION
    .else
      jmp @dwp    
    .endif

  .else
@dwp:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
 local wc:WNDCLASSEX
 local msg:MSG
 local hWnd:HWND
 mov wc.cbSize,sizeof wc
 mov wc.style,CS_DBLCLKS
 mov wc.lpfnWndProc,offset WndProc
 mov wc.cbClsExtra,0
 mov wc.cbWndExtra,0
 mov eax,hInst
 mov wc.hInstance,eax
 invoke LoadIcon,0,IDI_APPLICATION
 mov wc.hIcon,eax
 mov wc.hIconSm,eax
 invoke LoadCursor,0,IDC_HAND
 mov wc.hCursor,eax
 mov wc.hbrBackground,COLOR_WINDOW+2
 mov wc.lpszMenuName,0
 mov wc.lpszClassName,offset _class
 invoke RegisterClassEx,addr wc
 invoke CreateWindowEx,WS_EX_TOPMOST,\
     wc.lpszClassName,wc.lpszClassName,\
     WS_OVERLAPPEDWINDOW,\
     100,100,400,400,0,0,hInst,0
 mov hWnd,eax
 invoke ShowWindow,hWnd,CmdShow
 invoke UpdateWindow,hWnd
 .while TRUE
   invoke GetMessage,addr msg,NULL,0,0
   .break .if (!eax)
   invoke TranslateMessage,addr msg
   invoke DispatchMessage,addr msg
 .endw
 mov	eax,msg.wParam
 ret
WinMain endp

start:
 invoke GetModuleHandle,0
 invoke WinMain,eax,0,0,SW_SHOWDEFAULT
 invoke ExitProcess,eax
end start
